Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2232)
@@ -3533,41 +4052,45 @@
 !       REAL(wp) :: re_0 !< near-surface roughness Reynolds number
 
-
-       DO  i = nxlg, nxrg    
-          DO  j = nysg, nyng
-             IF ( water_surface(j,i) )  THEN
-
-!
-!--             Disabled: FLake parameterization. Ideally, the Charnock 
-!--             coefficient should depend on the water depth and the fetch
-!--             length
-!                re_0 = z0(j,i) * us(j,i) / molecular_viscosity
+       DO  m = 1, surf_lsm_h%ns
+
+          i   = surf_lsm_h%i(m)            
+          j   = surf_lsm_h%j(m)
+          
+          IF ( surf_lsm_h%water_surface(m) )  THEN
+
+!
+!--          Disabled: FLake parameterization. Ideally, the Charnock 
+!--          coefficient should depend on the water depth and the fetch
+!--          length
+!             re_0 = z0(j,i) * us(j,i) / molecular_viscosity
 !        
-!                z0(j,i) = MAX( 0.1_wp * molecular_viscosity / us(j,i),            &
-!                              alpha_ch * us(j,i) / g )
-!
-!                z0h(j,i) = z0(j,i) * EXP( - kappa / pr_number * ( 4.0_wp * SQRT( re_0 ) - 3.2_wp ) )
-!                z0q(j,i) = z0(j,i) * EXP( - kappa / pr_number * ( 4.0_wp * SQRT( re_0 ) - 4.2_wp ) )
-
-!
-!--              Set minimum roughness length for u* > 0.2
-!                IF ( us(j,i) > 0.2_wp )  THEN
-!                   z0h(j,i) = MAX( 1.0E-5_wp, z0h(j,i) )
-!                   z0q(j,i) = MAX( 1.0E-5_wp, z0q(j,i) )
-!                ENDIF
-
-!
-!--             ECMWF IFS model parameterization after Beljaars (1994). At low
-!--             wind speed, the sea surface becomes aerodynamically smooth and
-!--             the roughness scales with the viscosity. At high wind speed, the
-!--             Charnock relation is used.
-                z0(j,i) =   ( 0.11_wp * molecular_viscosity / us(j,i) )        &
-                          + ( alpha_ch * us(j,i)**2 / g )
-
-                z0h(j,i) = 0.40_wp * molecular_viscosity / us(j,i)
-                z0q(j,i) = 0.62_wp * molecular_viscosity / us(j,i)
-
-             ENDIF
-          ENDDO
+!             z0(j,i) = MAX( 0.1_wp * molecular_viscosity / us(j,i),            &
+!                           alpha_ch * us(j,i) / g )
+!
+!             z0h(j,i) = z0(j,i) * EXP( - kappa / pr_number * ( 4.0_wp * SQRT( re_0 ) - 3.2_wp ) )
+!             z0q(j,i) = z0(j,i) * EXP( - kappa / pr_number * ( 4.0_wp * SQRT( re_0 ) - 4.2_wp ) )
+
+!
+!--           Set minimum roughness length for u* > 0.2
+!             IF ( us(j,i) > 0.2_wp )  THEN
+!                z0h(j,i) = MAX( 1.0E-5_wp, z0h(j,i) )
+!                z0q(j,i) = MAX( 1.0E-5_wp, z0q(j,i) )
+!             ENDIF
+
+!
+!--          ECMWF IFS model parameterization after Beljaars (1994). At low
+!--          wind speed, the sea surface becomes aerodynamically smooth and
+!--          the roughness scales with the viscosity. At high wind speed, the
+!--          Charnock relation is used.
+             surf_lsm_h%z0(m)  = ( 0.11_wp * molecular_viscosity /             &
+                                 surf_lsm_h%us(m) )  &
+                               + ( alpha_ch * surf_lsm_h%us(m)**2 / g )
+
+             surf_lsm_h%z0h(m) = 0.40_wp * molecular_viscosity /               &
+                                 surf_lsm_h%us(m)
+             surf_lsm_h%z0q(m) = 0.62_wp * molecular_viscosity /               &
+                                 surf_lsm_h%us(m)
+
+          ENDIF
        ENDDO
 
@@ -3575,54 +4098,4 @@
 
 
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Calculation of specific humidity of the skin layer (surface). It is assumend
-!> that the skin is always saturated.
-!------------------------------------------------------------------------------!
-    SUBROUTINE calc_q_surface
-
-       IMPLICIT NONE
-
-       INTEGER :: i              !< running index
-       INTEGER :: j              !< running index
-       INTEGER :: k              !< running index
-
-       REAL(wp) :: resistance    !< aerodynamic and soil resistance term
-
-       DO  i = nxlg, nxrg    
-          DO  j = nysg, nyng
-             k = nzb_s_inner(j,i)
-
-!
-!--          Calculate water vapour pressure at saturation
-             e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( t_surface_p(j,i)   &
-                   - 273.16_wp ) / ( t_surface_p(j,i) - 35.86_wp ) )
-
-!
-!--          Calculate specific humidity at saturation
-             q_s = 0.622_wp * e_s / surface_pressure
-
-             resistance = r_a(j,i) / (r_a(j,i) + r_s(j,i))
-
-!
-!--          Calculate specific humidity at surface
-             IF ( cloud_physics )  THEN
-                q(k,j,i) = resistance * q_s + (1.0_wp - resistance)            &
-                             * ( q(k+1,j,i) - ql(k+1,j,i) )
-             ELSE
-                q(k,j,i) = resistance * q_s + (1.0_wp - resistance)            &
-                             * q(k+1,j,i)
-             ENDIF
-
-!
-!--          Update virtual potential temperature
-             vpt(k,j,i) = pt(k,j,i) * ( 1.0_wp + 0.61_wp * q(k,j,i) )
-
-          ENDDO
-       ENDDO
-
-    END SUBROUTINE calc_q_surface
-
 
  END MODULE land_surface_model_mod
Index: /palm/trunk/SOURCE/lpm.f90
===================================================================
--- /palm/trunk/SOURCE/lpm.f90	(revision 2231)
+++ /palm/trunk/SOURCE/lpm.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments to new topography concept
 ! 
 ! Former revisions:
@@ -123,5 +123,5 @@
 
     USE indices,                                                               &
-        ONLY: nxl, nxr, nys, nyn, nzb, nzb_max, nzt, nzb_w_inner
+        ONLY: nxl, nxr, nys, nyn, nzb, nzb_max, nzt
 
     USE kinds
@@ -365,5 +365,4 @@
 !--    Increment time since last release
        IF ( dt_3d_reached )  time_prel = time_prel + dt_3d
-
 !
 !--    Move Particles local to PE to a different grid cell
Index: /palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_advec.f90	(revision 2231)
+++ /palm/trunk/SOURCE/lpm_advec.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments to new topography and surface concept
 ! 
 ! Former revisions:
@@ -109,5 +109,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  de_dx, de_dy, de_dz, diss, e, km, u, us, usws, v, vsws, w, zu, zw
+        ONLY:  de_dx, de_dy, de_dz, diss, e, km, u, v, w, zu, zw
 
     USE cpulog
@@ -123,5 +123,5 @@
         
     USE indices,                                                               &
-        ONLY:  nzb, nzb_s_inner, nzt
+        ONLY:  nzb, nzb_max, nzt, wall_flags_0
         
     USE kinds
@@ -136,4 +136,7 @@
         ONLY:  hom
 
+    USE surface_mod,                                                           &
+        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+
     IMPLICIT NONE
 
@@ -147,4 +150,5 @@
     INTEGER(iwp) ::  jlog                        !< index variable along y 
     INTEGER(iwp) ::  k                           !< index variable along z 
+    INTEGER(iwp) ::  k_wall                      !< vertical index of topography top 
     INTEGER(iwp) ::  kp                          !< index variable along z 
     INTEGER(iwp) ::  kw                          !< index variable along z
@@ -152,4 +156,5 @@
     INTEGER(iwp) ::  nb                          !< block number particles are sorted in
     INTEGER(iwp) ::  num_gp                      !< number of adjacent grid points inside topography 
+    INTEGER(iwp) ::  surf_start                  !< Index on surface data-type for current grid box 
 
     INTEGER(iwp), DIMENSION(0:7) ::  start_index !< start particle index for current block
@@ -194,6 +199,8 @@
     REAL(wp) ::  u_int_u            !< x/y-interpolated u-component at particle position at upper vertical level
     REAL(wp) ::  us_int             !< friction velocity at particle grid box
+    REAL(wp) ::  usws_int           !< surface momentum flux (u component) at particle grid box
     REAL(wp) ::  v_int_l            !< x/y-interpolated v-component at particle position at lower vertical level
     REAL(wp) ::  v_int_u            !< x/y-interpolated v-component at particle position at upper vertical level
+    REAL(wp) ::  vsws_int           !< surface momentum flux (u component) at particle grid box
     REAL(wp) ::  vv_int             !<
     REAL(wp) ::  w_int_l            !< x/y-interpolated w-component at particle position at lower vertical level
@@ -258,6 +265,4 @@
        j = jp + block_offset(nb)%j_off
        k = kp + block_offset(nb)%k_off
-
-
 !
 !--    Interpolate u velocity-component
@@ -271,18 +276,24 @@
 !--       Monin-Obukhov relations (if branch). 
 !--       First, check if particle is located below first vertical grid level 
-!--       (Prandtl-layer height)
+!--       above topography (Prandtl-layer height)
           ilog = ( particles(n)%x + 0.5_wp * dx ) * ddx
           jlog = ( particles(n)%y + 0.5_wp * dy ) * ddy
-
-          IF ( constant_flux_layer  .AND.                                      &
-               zv(n) - zw(nzb_s_inner(jlog,ilog)) < z_p )  THEN
+!
+!--       Determine vertical index of topography top
+          k_wall = MAXLOC(                                                     &
+                       MERGE( 1, 0,                                            &
+                              BTEST( wall_flags_0(nzb:nzb_max,jlog,ilog), 12 ) &
+                            ), DIM = 1                                         &
+                         ) - 1
+
+          IF ( constant_flux_layer  .AND.  zv(n) - zw(k_wall) < z_p )  THEN
 !
 !--          Resolved-scale horizontal particle velocity is zero below z0. 
-             IF ( zv(n) - zw(nzb_s_inner(jlog,ilog)) < z0_av_global )  THEN
+             IF ( zv(n) - zw(k_wall) < z0_av_global )  THEN
                 u_int(n) = 0.0_wp
              ELSE
 !
 !--             Determine the sublayer. Further used as index.
-                height_p = ( zv(n) - zw(nzb_s_inner(jlog,ilog)) - z0_av_global ) &
+                height_p = ( zv(n) - zw(k_wall) - z0_av_global ) &
                                      * REAL( number_of_sublayers, KIND=wp )    &
                                      * d_z_p_z0 
@@ -296,9 +307,26 @@
                                    ) 
 !
-!--             Limit friction velocity. In narrow canyons or holes the 
-!--             friction velocity can become very small, resulting in a too
-!--             large particle speed.
-                us_int   = MAX( 0.5_wp * ( us(jlog,ilog) + us(jlog,ilog-1) ),  &
-                                0.01_wp )  
+!--             Get friction velocity and momentum flux from new surface data 
+!--             types.
+                IF ( surf_def_h(0)%start_index(jlog,ilog) <=                   &
+                     surf_def_h(0)%end_index(jlog,ilog) )  THEN
+                   surf_start = surf_def_h(0)%start_index(jlog,ilog)
+!--                Limit friction velocity. In narrow canyons or holes the 
+!--                friction velocity can become very small, resulting in a too
+!--                large particle speed.
+                   us_int    = MAX( surf_def_h(0)%us(surf_start), 0.01_wp )  
+                   usws_int  = surf_def_h(0)%usws(surf_start)
+                ELSEIF ( surf_lsm_h%start_index(jlog,ilog) <=                  &
+                         surf_lsm_h%end_index(jlog,ilog) )  THEN
+                   surf_start = surf_lsm_h%start_index(jlog,ilog)
+                   us_int    = MAX( surf_lsm_h%us(surf_start), 0.01_wp )  
+                   usws_int  = surf_lsm_h%usws(surf_start)
+                ELSEIF ( surf_usm_h%start_index(jlog,ilog) <=                  &
+                         surf_usm_h%end_index(jlog,ilog) )  THEN
+                   surf_start = surf_usm_h%start_index(jlog,ilog)
+                   us_int    = MAX( surf_usm_h%us(surf_start), 0.01_wp )  
+                   usws_int  = surf_usm_h%usws(surf_start)
+                ENDIF
+
 !
 !--             Neutral solution is applied for all situations, e.g. also for 
@@ -308,5 +336,5 @@
 !--             as sensitivity studies revealed no significant effect of 
 !--             using the neutral solution also for un/stable situations.
-                u_int(n) = -usws(jlog,ilog) / ( us_int * kappa + 1E-10_wp )          & 
+                u_int(n) = -usws_int / ( us_int * kappa + 1E-10_wp )           & 
                             * log_z_z0_int - u_gtrans
                 
@@ -352,8 +380,14 @@
           ilog = ( particles(n)%x + 0.5_wp * dx ) * ddx
           jlog = ( particles(n)%y + 0.5_wp * dy ) * ddy
-          IF ( constant_flux_layer  .AND.                                      &
-               zv(n) - zw(nzb_s_inner(jlog,ilog)) < z_p )  THEN
-
-             IF ( zv(n) - zw(nzb_s_inner(jlog,ilog)) < z0_av_global )  THEN
+!
+!--       Determine vertical index of topography top
+          k_wall = MAXLOC(                                                     &
+                       MERGE( 1, 0,                                            &
+                              BTEST( wall_flags_0(nzb:nzb_max,jlog,ilog), 12 ) &
+                            ), DIM = 1                                         &
+                         ) - 1
+
+          IF ( constant_flux_layer  .AND.  zv(n) - zw(k_wall) < z_p )  THEN
+             IF ( zv(n) - zw(k_wall) < z0_av_global )  THEN
 !
 !--             Resolved-scale horizontal particle velocity is zero below z0. 
@@ -365,5 +399,5 @@
 !--             topography particle on u-grid can be above surface-layer height,
 !--             whereas it can be below on v-grid. 
-                height_p = ( zv(n) - zw(nzb_s_inner(jlog,ilog)) - z0_av_global ) &
+                height_p = ( zv(n) - zw(k_wall) - z0_av_global ) &
                                   * REAL( number_of_sublayers, KIND=wp )       &
                                   * d_z_p_z0 
@@ -377,9 +411,25 @@
                                    ) 
 !
-!--             Limit friction velocity. In narrow canyons or holes the 
-!--             friction velocity can become very small, resulting in a too
-!--             large particle speed.
-                us_int   = MAX( 0.5_wp * ( us(jlog,ilog) + us(jlog-1,ilog) ),  &
-                                0.01_wp )    
+!--             Get friction velocity and momentum flux from new surface data 
+!--             types.
+                IF ( surf_def_h(0)%start_index(jlog,ilog) <=                   &
+                     surf_def_h(0)%end_index(jlog,ilog) )  THEN
+                   surf_start = surf_def_h(0)%start_index(jlog,ilog)
+!--                Limit friction velocity. In narrow canyons or holes the 
+!--                friction velocity can become very small, resulting in a too
+!--                large particle speed.
+                   us_int    = MAX( surf_def_h(0)%us(surf_start), 0.01_wp )  
+                   vsws_int  = surf_def_h(0)%usws(surf_start)
+                ELSEIF ( surf_lsm_h%start_index(jlog,ilog) <=                  &
+                         surf_lsm_h%end_index(jlog,ilog) )  THEN
+                   surf_start = surf_lsm_h%start_index(jlog,ilog)
+                   us_int    = MAX( surf_lsm_h%us(surf_start), 0.01_wp )  
+                   vsws_int  = surf_lsm_h%usws(surf_start)
+                ELSEIF ( surf_usm_h%start_index(jlog,ilog) <=                  &
+                         surf_usm_h%end_index(jlog,ilog) )  THEN
+                   surf_start = surf_usm_h%start_index(jlog,ilog)
+                   us_int    = MAX( surf_usm_h%us(surf_start), 0.01_wp )  
+                   vsws_int  = surf_usm_h%usws(surf_start)
+                ENDIF 
 !
 !--             Neutral solution is applied for all situations, e.g. also for 
@@ -389,5 +439,5 @@
 !--             as sensitivity studies revealed no significant effect of 
 !--             using the neutral solution also for un/stable situations.
-                v_int(n) = -vsws(jlog,ilog) / ( us_int * kappa + 1E-10_wp )    &
+                v_int(n) = -vsws_int / ( us_int * kappa + 1E-10_wp )           &
                          * log_z_z0_int - v_gtrans
 
@@ -622,5 +672,15 @@
              num_gp = 0
 
-             IF ( k > nzb_s_inner(j,i)  .OR.  nzb_s_inner(j,i) == 0 )  THEN 
+!
+!--          Determine vertical index of topography top at (j,i)
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j,i), 12 )    &
+                               ), DIM = 1                                      &
+                            ) - 1
+!
+!--          To do: Reconsider order of computations in order to avoid 
+!--          unnecessary index calculations.
+             IF ( k > k_wall  .OR.  k_wall == 0 )  THEN 
                 num_gp = num_gp + 1
                 gp_outside_of_building(1) = 1
@@ -634,5 +694,13 @@
                 de_dzi(num_gp) = de_dz(k,j,i)
              ENDIF
-             IF ( k > nzb_s_inner(j+1,i)  .OR.  nzb_s_inner(j+1,i) == 0 )  THEN
+
+!
+!--          Determine vertical index of topography top at (j+1,i)
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j+1,i), 12 )  &
+                               ), DIM = 1                                      &
+                            ) - 1
+             IF ( k > k_wall  .OR.  k_wall == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(2) = 1
@@ -647,5 +715,12 @@
              ENDIF
 
-             IF ( k+1 > nzb_s_inner(j,i)  .OR.  nzb_s_inner(j,i) == 0 )  THEN
+!
+!--          Determine vertical index of topography top at (j,i)
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j,i), 12 )    &
+                               ), DIM = 1                                      &
+                            ) - 1
+             IF ( k+1 > k_wall  .OR.  k_wall == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(3) = 1
@@ -660,5 +735,12 @@
              ENDIF
 
-             IF ( k+1 > nzb_s_inner(j+1,i)  .OR.  nzb_s_inner(j+1,i) == 0 )  THEN
+!
+!--          Determine vertical index of topography top at (j+1,i)
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j+1,i), 12 )  &
+                               ), DIM = 1                                      &
+                            ) - 1
+             IF ( k+1 > k_wall  .OR.  k_wall == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(4) = 1
@@ -673,5 +755,12 @@
              ENDIF
 
-             IF ( k > nzb_s_inner(j,i+1)  .OR.  nzb_s_inner(j,i+1) == 0 )  THEN
+!
+!--          Determine vertical index of topography top at (j,i+1)
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j,i+1), 12 )  &
+                               ), DIM = 1                                      &
+                            ) - 1
+             IF ( k > k_wall  .OR.  k_wall == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(5) = 1
@@ -686,5 +775,12 @@
              ENDIF
 
-             IF ( k > nzb_s_inner(j+1,i+1)  .OR.  nzb_s_inner(j+1,i+1) == 0 )  THEN
+!
+!--          Determine vertical index of topography top at (j+1,i+1)
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j+1,i+1), 12 )&
+                               ), DIM = 1                                      &
+                            ) - 1
+             IF ( k > k_wall  .OR.  k_wall == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(6) = 1
@@ -699,5 +795,12 @@
              ENDIF
 
-             IF ( k+1 > nzb_s_inner(j,i+1)  .OR.  nzb_s_inner(j,i+1) == 0 )  THEN
+!
+!--          Determine vertical index of topography top at (j,i+1)
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j,i+1), 12 )  &
+                               ), DIM = 1                                      &
+                            ) - 1
+             IF ( k+1 > k_wall  .OR.  k_wall == 0 )  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(7) = 1
@@ -712,5 +815,12 @@
              ENDIF
 
-             IF ( k+1 > nzb_s_inner(j+1,i+1)  .OR.  nzb_s_inner(j+1,i+1) == 0)  THEN
+!
+!--          Determine vertical index of topography top at (j+1,i+1)
+             k_wall = MAXLOC(                                                  &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j+1,i+1), 12 )&
+                               ), DIM = 1                                      &
+                            ) - 1
+             IF ( k+1 > k_wall  .OR.  k_wall == 0)  THEN
                 num_gp = num_gp + 1
                 gp_outside_of_building(8) = 1
Index: /palm/trunk/SOURCE/lpm_boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 2231)
+++ /palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 2232)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography and surface concept
+! Rename character range into location, as range is an intrinsic. 
 ! 
 ! Former revisions:
@@ -78,5 +79,5 @@
 !> (see offset_ocean_*)
 !------------------------------------------------------------------------------!
- SUBROUTINE lpm_boundary_conds( range )
+ SUBROUTINE lpm_boundary_conds( location )
  
 
@@ -94,5 +95,5 @@
 
     USE indices,                                                               &
-        ONLY:  nxl, nxr, nyn, nys, nz, nzb_s_inner
+        ONLY:  nxl, nxr, nyn, nys, nz, nzb, nzb_max, wall_flags_0
 
     USE kinds
@@ -107,5 +108,5 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  range     !<
+    CHARACTER (LEN=*) ::  location     !<
     
     INTEGER(iwp) ::  inc            !< dummy for sorting algorithmus
@@ -118,4 +119,5 @@
     INTEGER(iwp) ::  j2             !< grid index (x) of current particle position
     INTEGER(iwp) ::  j3             !< grid index (x) of intermediate particle position
+    INTEGER(iwp) ::  k_wall         !< vertical index of topography top
     INTEGER(iwp) ::  n              !< particle number
     INTEGER(iwp) ::  t_index        !< running index for intermediate particle timesteps in reflection algorithmus
@@ -167,5 +169,5 @@
 
 
-    IF ( range == 'bottom/top' )  THEN
+    IF ( location == 'bottom/top' )  THEN
 
 !
@@ -232,5 +234,5 @@
        ENDDO
 
-    ELSEIF ( range == 'walls' )  THEN
+    ELSEIF ( location == 'walls' )  THEN
 
 
@@ -281,9 +283,27 @@
           ENDIF
 !
-!--       Walls aligned in xy layer at which particle can be possiblly reflected
-          zwall1 = zw(nzb_s_inner(j2,i2))
-          zwall2 = zw(nzb_s_inner(j1,i1))
-          zwall3 = zw(nzb_s_inner(j1,i2))
-          zwall4 = zw(nzb_s_inner(j2,i1))
+!--       Walls aligned in xy layer at which particle can be possiblly reflected.
+!--       The construct of MERGE and BTEST is used to determine the topography-
+!--       top index (former nzb_s_inner). 
+          zwall1 = zw( MAXLOC(                                                 &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j2,i2), 12 )  &
+                               ), DIM = 1                                      &
+                             ) - 1 )                                             
+          zwall2 = zw( MAXLOC(                                                 &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j1,i1), 12 )  &
+                               ), DIM = 1                                      &
+                             ) - 1 )  
+          zwall3 = zw( MAXLOC(                                                 &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j1,i2), 12 )  &
+                               ), DIM = 1                                      &
+                             ) - 1 )  
+          zwall4 = zw( MAXLOC(                                                 &
+                          MERGE( 1, 0,                                         &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j2,i1), 12 )  &
+                               ), DIM = 1                                      &
+                             ) - 1 )  
 !
 !--       Initialize flags to check if particle reflection is necessary
@@ -469,7 +489,12 @@
 !--             constant is required, as the particle position do not 
 !--             necessarily exactly match the wall location due to rounding 
-!--             errors.   
+!--             errors. At first, determine index of topography top at (j3,i3)  
+                k_wall = MAXLOC(                                               &
+                            MERGE( 1, 0,                                       &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j3,i3), 12 )  &
+                                 ), DIM = 1                                    &
+                               ) - 1  
                 IF ( ABS( pos_x - xwall ) < eps      .AND.                     &
-                     pos_z <= zw(nzb_s_inner(j3,i3)) .AND.                     &
+                     pos_z <= zw(k_wall)             .AND.                     &
                      reach_x(t_index)                .AND.                     &
                      .NOT. reflect_x )  THEN
@@ -504,7 +529,13 @@
 !
 !--             Check if a particle needs to be reflected at any xz-wall. If 
-!--             necessary, carry out reflection.
+!--             necessary, carry out reflection. At first, determine index of
+!--             topography top at (j3,i3)  
+                k_wall = MAXLOC(                                               &
+                            MERGE( 1, 0,                                       &
+                                 BTEST( wall_flags_0(nzb:nzb_max,j3,i3), 12 )  &
+                                 ), DIM = 1                                    &
+                               ) - 1  
                 IF ( ABS( pos_y - ywall ) < eps      .AND.                     &
-                     pos_z <= zw(nzb_s_inner(j3,i3)) .AND.                     &
+                     pos_z <= zw(k_wall)             .AND.                     &
                      reach_y(t_index)                .AND.                     &
                      .NOT. reflect_y ) THEN
@@ -525,11 +556,19 @@
 !
 !--             Check if a particle needs to be reflected at any xy-wall. If 
-!--             necessary, carry out reflection.
+!--             necessary, carry out reflection. 
                 IF ( downwards .AND. reach_z(t_index) .AND.                    &
                      .NOT. reflect_z )  THEN
-                   IF ( pos_z - zw(nzb_s_inner(j3,i3)) < eps ) THEN
+!
+!--                Determine index of topography top at (j3,i3) and chick if
+!--                particle is below.  
+                   k_wall = MAXLOC(                                            &
+                          MERGE( 1, 0,                                         &
+                                   BTEST( wall_flags_0(nzb:nzb_max,j3,i3), 12 )&
+                               ), DIM = 1                                      &
+                                  ) - 1  
+                   IF ( pos_z - zw(k_wall) < eps ) THEN
   
-                      pos_z = MAX( 2.0_wp * zw(nzb_s_inner(j3,i3)) - pos_z,    &
-                                   zw(nzb_s_inner(j3,i3)) )
+                      pos_z = MAX( 2.0_wp * zw(k_wall) - pos_z,    &
+                                   zw(k_wall) )
 
                       particles(n)%speed_z = - particles(n)%speed_z
